// Avoid `console` errors in browsers that lack a console.
(function() {
    var method;
    var noop = function () {};
    var methods = [
        'assert', 'clear', 'count', 'debug', 'dir', 'dirxml', 'error',
        'exception', 'group', 'groupCollapsed', 'groupEnd', 'info', 'log',
        'markTimeline', 'profile', 'profileEnd', 'table', 'time', 'timeEnd',
        'timeline', 'timelineEnd', 'timeStamp', 'trace', 'warn'
    ];
    var length = methods.length;
    var console = (window.console = window.console || {});
    
    while (length--) {
        method = methods[length];

        // Only stub undefined methods.
        if (!console[method]) {
            console[method] = noop;
        }
    }
}());

// Place any jQuery/helper plugins in here.
// Colocar los plugins realizados por nosotros...

(function($) {
  
  $.fn.init_admin = function(options){
    var _options = $.extend({}, $.fn.init_admin.defaults, options);
    
    this.each(function(){
        
        var $this = $(this);
        
        var _fadeSpeed = _options.fadeSpeed;
        var _chromeframe = _options.notif_chromeframe;
        var _vresolution = _options.view_resolution;
        
        
        if(_fadeSpeed){
            $this.css({ 'display': 'none' }).fadeIn(_fadeSpeed)
        }
        
        if(_chromeframe){
            $this.prepend('<!--[if lt IE 7]><p class="chromeframe">Est&aacute;s usando un navegador <strong>obsoleto</strong>. Por favor <a href="http://browsehappy.com/">actual&iacute;zalo</a> &oacute; <a href="http://www.google.com/chromeframe/?redirect=true">activa Google Chrome Frame</a> para mejorar su experiencia de navegaci&oacute;n.</p><![endif]-->');
        }
        
        if(_vresolution){
            $this.prepend('<div class="statics"></div>');
            if($(".statics").length){
                $(".statics").css({
                    "background": "#fff",
                    "opacity": "0.3",
                    "margin": "0 0",
                    "padding": "10px",
                    "font-size": "10px",
                    "z-index": "999999999",
                    "position": "fixed"
                });
                $(".statics").html('<i class="fa fa-desktop"></i> ' + $(window).width() + 'px | ' + $(window).height() + 'px &nbsp;&nbsp; <i class="showGrids fa fa-th" style="cursor:pointer;" onclick="showGrids();"></i>');
                $(window).resize(function() {
                    $(".statics").html('<i class="fa fa-desktop"></i> ' + $(window).width() + 'px | ' + $(window).height() + 'px &nbsp;&nbsp; <i class="showGrids fa fa-th" style="cursor:pointer;" onclick="showGrids();"></i>');
                });
            }
        }
        
    });
    
  }
  $.fn.init_admin.defaults = {
    fadeSpeed: false,
    notif_chromeframe: false,
    view_resolution: false
  }
  
})(jQuery);

function showGrids(){
    $( ".grillas" ).fadeToggle();
}