/**
 * PeloSlide - for jQuery
 * @name peloslide.v1.0.js
 * @author Cabello, Hector Guillermo - http://www.kbzone.com.ar
 * @version 1.0.5
 * @date 21-Jun-2009
 * @copyright (c) 2009 Cabello, Hector Guillermo (http://www.kbzone.com.ar)
 * @license MIT - http://es.wikipedia.org/wiki/Licencia_MIT
 * @example (empty)
 * @features:
 * * (empty)
*/

/*
Class: PeloSlide
	Pequeño slide show de imágenes

Arguments:
	options - see Options below

Options:
	keyboard - (boolean) Posibilidad de habilitar la navegación mediante teclado.
*/

(function($) {
	$.fn.peloslide = function(options) {

		var defaults = {
			keyboard : true
		}, settings = $.extend({}, defaults, options);
		
		var Total = options.imagenes.length;
		//var gActual = settings.iniciar;
		var ancla = location.toString();
		ancla = ancla.split('#')[1];
		ancla = ancla.split('=');
		var gActual = parseInt(ancla[1]);
		$('#idfoto').val(settings.id_fotos[gActual]);
		$('#form1').attr('action','mirame.php?cat_id='+settings.id_album+'#foto='+gActual);
		
		if (gActual > 0) {
			var gAnterior = gActual - 1;
		} else {
			var gAnterior = Total - 1;
		}
		if (gActual == (Total - 1)) {
			var gSiguiente = 0;
		} else {
			var gSiguiente = gActual + 1;
		}
		
		if (screen.height >= 770) {
			$('#contenedor').css({height:'770px'});
		}
		//alert("Total: " + (Total - 1) + "Anterior: " + gAnterior + " - Actual: "+gActual+" - Siguiente: "+gSiguiente);
		
		/* Agrego efecto fade a los botones */
		$(".izquierda").each(function(index) {
			$(this).fadeTo("fast", 0.1);
			$(this).hover(function(){
				$(this).fadeTo("fast", 1.0);
			},function(){
				$(this).fadeTo("fast", 0.1);
			});
		});
		$(".derecha").each(function(index) {
			$(this).fadeTo("fast", 0.1);
			$(this).hover(function(){
				$(this).fadeTo("fast", 1.0);
			},function(){
				$(this).fadeTo("fast", 0.1);
			});
		});
		
		$('.izquierda').click( function() {
			volver();
			//return false;
		});
		$('.derecha').click( function() {
			siguiente();
			//return false;
		});
		
		$('.mini_back').click( function() {
			volver();
			//return false;
		});
		$('.mini_next').click( function() {
			siguiente();
			//return false;
		});
		
		/* Agrego funciones correspondientes a los botones */
		$('a[rel="volver"]').click( function() {volver();return false;});
		$('a[rel="siguiente"]').click( function() {siguiente();return false;});
		
		if (settings.keyboard == true) {
			/* Agrego funciones de teclado a los botones */
			$(document).bind('keydown', function(event){
				if (event.keyCode == 39){
					siguiente();
				} else if (event.keyCode == 37){
					volver();
				} else if (event.keyCode == 27){
					close();
				}
			});
		}
		
		init();

		function init() {
			/* Agrego las imagenes de la galeria */
			var show;
			var src;
			var Append = "";
			for (var i=0;i<3;i++) {
				if (i == 0) {
					src = settings.imagenes[gAnterior];
					show = ' class="antes"';
					//precargar(src);
				} else if (i == 1) {
					src = settings.imagenes[gActual];
					show = ' class="show"';
					preload_img = src;
					//precargar(preload_img);
				} else if (i == 2) {
					src = settings.imagenes[gSiguiente];
					show = ' class="despues"';
					//precargar(src);
				} else {
					show = '';
					src = '';
				}
				var Append = Append + '<a href="#"' + show + '><img src="' + src + '" /></a>';
			}
			
			$(".fotos").append(Append);
			$('.fotos a').css({opacity: 0.0});
			$('.show').css({opacity: 1.0});
			$('.botonera a').css({opacity: 1.0});
			
			precargar(preload_img);
			suma_visita(settings.id_album,settings.id_fotos[gActual])
			
			var preload_back = new Image();
			preload_back.src = settings.imagenes[gAnterior];

			var preload_next = new Image();
			preload_next.src = settings.imagenes[gSiguiente];

			var preload_next_next = new Image();
			preload_next_next.src = settings.imagenes[gSiguiente + 1];

			var preload_back_back = new Image();
			preload_back.preload_back_back = settings.imagenes[gAnterior - 1];
			
		}

		function precargar(src_imagen) {
			var preload = new Image();
			preload.src = src_imagen;
			preload.onload = function() {
				var id_actual = settings.tamanos[gActual].split(",");
				acomodar_elementos(id_actual[0],id_actual[1]);
			};
		}
		
		function suma_visita(id_cat,id_foto) {
			$.ajax({
					type: "GET",
					url: "update_visitas_fotos.php"//,
					//data: "id_foto="+id_foto+"&cat_id="+id_cat,
					//success: function(datos){
						//alert(datos);
					//}
			});
			//x = top.frames['iframe_contador'].location = "http://www.turismoquovadis.com.ar/contador.php?cat_id="+id_cat+"&foto="+id_foto;
		}
		
		/*function imgLoad(img, completeCallback, errorCallback){
			if(img!=null && completeCallback!=null){
				var loadWatch = setInterval(watch, 100);
				function watch(){
					if(img.complete){
						clearInterval(loadWatch);
						completeCallback(img);
					}
				}
			}else{
				if(typeof errorCallback=="function") errorCallback();
			}
		}*/

		function siguiente() {
			gSiguiente++;
			if (gSiguiente > (Total - 1)) gSiguiente = 0;
			gActual++;
			if (gActual > (Total - 1)) gActual = 0;
			gAnterior++;
			if (gAnterior > (Total - 1)) gAnterior = 0;
			
			location.hash = 'foto='+gActual;
			$('#idfoto').val(settings.id_fotos[gActual]);
			$('#form1').attr('action','mirame.php?cat_id='+settings.id_album+'#foto='+gActual);
		
			preload_next_next = Array;
			preload_next_next[gSiguiente] = new Image();
			preload_next_next[gSiguiente].src = settings.imagenes[gSiguiente];
			//preload_next_next.onload = test("cargo");
			suma_visita(settings.id_album,settings.id_fotos[gActual])
			
			var antes = $('.fotos a.antes');
			var current = $('.fotos a.show');
			var next = $('.fotos a.despues');
			antes.remove();

			next.css({opacity: 0.0}).removeClass('despues').addClass('show').animate({opacity: 1.0}, 1000);
			current.animate({opacity: 0.0}, 1000).removeClass('show').addClass('antes');
			
			Append = '<a href="#" class="despues"><img src="' + settings.imagenes[gSiguiente] + '" /></a>';
			$(".fotos").append(Append);
			$('.fotos a.despues').css({opacity: 0.0});

			var id_actual = settings.tamanos[gActual].split(",");
			acomodar_elementos(id_actual[0],id_actual[1]);
			
			/*var pre_next = gSiguiente;*/
			
			/*pre_next++;
			if (pre_next > (Total - 1)) pre_next = 0;
			
			var preload_next_next_next = new Image();
			preload_next_next_next.src = settings.imagenes[pre_next];
			//preload_next_next.onload = function() {};
			
			pre_next++;
			if (pre_next > (Total - 1)) pre_next = 0;
			
			var preload_next_next_next_next = new Image();
			preload_next_next_next_next.src = settings.imagenes[pre_next];*/
			//preload_next_next.onload = function() {};
			
			/*var width_galeria = $('.show img').width();
			var height_galeria = $('.show img').height();
			var nuevo_height = (height_galeria / 2) - ($('a[rel="siguiente"] img').height() / 2);
			//$('.botonera').animate({width:width_galeria,top:nuevo_height+"px"},"slow");
			//alert(height_galeria);
			$('.izquierda').css({height:height_galeria+"px",'padding-top':nuevo_height+"px"});
			$('.derecha').css({height:height_galeria+"px",'padding-top':nuevo_height+"px"});
			$('.botonera').animate({width:width_galeria},"slow");*/
		}
		
		function volver() {
			gAnterior--;
			if (gAnterior < 0) gAnterior = Total - 1;
			gActual--;
			if (gActual < 0) gActual = Total - 1;
			gSiguiente--;
			if (gSiguiente < 0) gSiguiente = Total - 1;
			
			location.hash = 'foto='+gActual;
			$('#idfoto').val(settings.id_fotos[gActual]);
			$('#form1').attr('action','mirame.php?cat_id='+settings.id_album+'#foto='+gActual);

			preload_back_back = Array;
			preload_back_back[gAnterior] = new Image();
			preload_back_back[gAnterior].src = settings.imagenes[gAnterior];
			//preload_back_back.onload = function() {};
			suma_visita(settings.id_album,settings.id_fotos[gActual])
			
			//test("<strong>Anterior -></strong> Anterior: " + gAnterior + " | Siguiente: " + gSiguiente);
			
			var antes = $('.fotos a.antes');
			var current = $('.fotos a.show');
			var next = $('.fotos a.despues');
			next.remove();

			antes.css({opacity: 0.0}).removeClass('antes').addClass('show').animate({opacity: 1.0}, 1000);
			current.animate({opacity: 0.0}, 1000).removeClass('show').addClass('despues');
			
			//precargar(settings.imagenes[gAnterior]);
			Prepend = '<a href="#" class="antes"><img src="' + settings.imagenes[gAnterior] + '" /></a>';
			$(".fotos").prepend(Prepend);
			$('.fotos a.antes').css({opacity: 0.0});
			
			var id_actual = settings.tamanos[gActual].split(",");
			acomodar_elementos(id_actual[0],id_actual[1])
			
			/*var preload_back_back_back = new Image();
			preload_back_back_back.src = settings.imagenes[gAnterior - 1];
			//preload_back_back.onload = function() {};
			
			var preload_back_back_back_back = new Image();
			preload_back_back_back.src = settings.imagenes[gAnterior - 2];
			//preload_back_back.onload = function() {};*/
			
			/*var width_galeria = $('.show img').width();
			var height_galeria = $('.show img').height();
			var nuevo_height = (height_galeria / 2) - ($('a[rel="siguiente"] img').height() / 2);
			//$('.botonera').animate({width:width_galeria,top:nuevo_height+"px"},"slow");
			$('.izquierda').css({height:height_galeria+"px",'padding-top':nuevo_height+"px"});
			$('.derecha').css({height:height_galeria+"px",'padding-top':nuevo_height+"px"});
			$('.botonera').animate({width:width_galeria},"slow");*/
		}
		
		function acomodar_elementos(img_width,img_height) {
			var width_galeria = img_width;
			var height_galeria = img_height;
			if (width_galeria > 750) {
				height_galeria = (img_height * 750) / img_width;
				width_galeria = 750;
			}
			if (height_galeria > 650) {
				width_galeria = (img_width * 650) / img_height;
				height_galeria = 650;
			}
			//alert(width_galeria + " " + height_galeria);
			var nuevo_height = (height_galeria / 2) - ($('a[rel="siguiente"] img').height() / 2);
			//$('.botonera').animate({width:width_galeria,top:nuevo_height+"px"},"slow");
			$('#contenido_popup').css({'height':height_galeria+'px'});
			$('#galeria').css({'width':'100%'});
			$('#wrap').css({'width':'100%','height':height_galeria+"px"});
			$('.fotos').css({'width':width_galeria+'px','margin':'0 auto'});
			$('.botonera').css({'width':width_galeria+'px','margin':'0 auto'});
			$('.show img').css({'width':width_galeria+'px'});
			$('.botonera').animate({'width':width_galeria+"px"},"slow");
			$('.izquierda').animate({'height':(height_galeria - nuevo_height)+"px",'paddingTop':nuevo_height+"px"},"slow");
			$('.derecha').animate({'height':(height_galeria - nuevo_height)+"px",'paddingTop':nuevo_height+"px"},"slow");
			var nuevo_left = $('#tabla').width() - width_galeria;
			nuevo_left = (nuevo_left / 2) - 0;
			$('.botonera').animate({'left':nuevo_left+'px'},"slow");
			//alert($('#tabla').width() + " - " + width_galeria + "= "+nuevo_left);
			/*var width_galeria = $('.show img').width();
			var height_galeria = $('.show img').height();
				//var nuevo_height = (height_galeria / 2) - ($('a[rel="siguiente"] img').height() / 2);
				//$('.botonera').css({top:nuevo_height+"px"});
			$('.botonera').css({width:width_galeria});
			$('.izquierda').css({height:height_galeria});
			$('.derecha').css({height:height_galeria});
			//$('.botonera').css({top:nuevo_height+"px"});
			//test("<strong>Init -></strong> Anterior: " + gAnterior + " | Siguiente: " + gSiguiente);*/
		}

		function test(str) {
			$('.test').append(str + "<br />");
		}

	};
})(jQuery);
